@ECHO OFF
IF NOT "%1"=="as_admin" (powershell start -verb runas '%0' as_admin & EXIT /B)

SET base=%~dp0
CD /D %base%

IF EXIST RDR2.exe GOTO installRDR2
IF EXIST mafiadefinitiveedition.exe GOTO installMDE1
ECHO This folder does not seem to belong to any of the supported games.
ECHO Please make sure that the mod is extracted to the folder where the main game executable is found.
GOTO abort


:installRDR2
ECHO *********************************************
ECHO * R.E.A.L. VR mod for Red Dead Redemption 2 *
ECHO *********************************************
ECHO(
CHOICE /C UHMLO /M "Select (U)ltra, (H)igh, (M)edium, (L)ow or HUB (O)ptimized config"
IF ERRORLEVEL 6 GOTO abort
IF NOT ERRORLEVEL 1 GOTO abort
IF ERRORLEVEL 1 SET cfg=1ultra
IF ERRORLEVEL 2 SET cfg=2high
IF ERRORLEVEL 3 SET cfg=3medium
IF ERRORLEVEL 4 SET cfg=4low
IF ERRORLEVEL 5 SET cfg=5hub

ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Copying game specific files...
COPY /Y RDR2\* .

ECHO Configuring Vulkan layers...
powershell "Remove-ItemProperty -Path HKCU:\SOFTWARE\Khronos\Vulkan\ImplicitLayers -Name *RealVR64.json"
powershell "Remove-ItemProperty -Path HKLM:\SOFTWARE\Khronos\Vulkan\ImplicitLayers -Name *RealVR64.json"
REG ADD HKLM\SOFTWARE\Khronos\Vulkan\ImplicitLayers /V "%base%RealVR64.json" /T REG_DWORD /D 0 /F

ECHO Installing graphics settings preset...
FOR /F "tokens=* USEBACKQ" %%F IN (`powershell "(new-object -COM Shell.Application).Namespace(0x05).Self.Path"`) DO SET doc=%%F
SET dst=%doc%\Rockstar Games\Red Dead Redemption 2\Settings\
IF EXIST "%dst%" (
    IF EXIST "%dst%system.xml" (
        IF NOT EXIST "%dst%system_ori.xml" REN "%dst%system.xml" system_ori.xml
    ) ELSE (
        ECHO WARNING: "%dst%system.xml" not found.
    )
) ELSE (
    ECHO WARNING: The game appears to never have been run. Creating new "%dst%system.xml" file.
    MKDIR "%dst%"
)
COPY /Y "RDR2\Settings\system_%cfg%.xml" "%dst%system.xml"

ECHO Cleaning up...
RMDIR /S /Q MDE1
GOTO finish


:installMDE1
ECHO *************************************************
ECHO * R.E.A.L. VR mod for Mafia: Definitive Edition *
ECHO *************************************************
ECHO(
ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Installing graphics settings preset...
FOR /F "tokens=* USEBACKQ" %%F IN (`powershell "(new-object -COM Shell.Application).Namespace(0x05).Self.Path"`) DO SET doc=%%F
SET dst=%doc%\My Games\Mafia Definitive Edition\
IF EXIST "%dst%" (
    FOR /F "delims=" %%D IN ('DIR /AD /B "%dst%Data"') DO (
        COPY /Y "MDE1\settings\profile_videosettings.pf" "%dst%Data\%%D\profiles\temporaryprofile"
        SET haveprofile=yes
    )
)
IF NOT DEFINED haveprofile (
    ECHO(
    ECHO ERROR: The game appears to never have been run. Run the game at least once to
    ECHO        create your user profile, then quit it and try installing the mod again.
    ECHO(
    GOTO abort
)
COPY /Y "MDE1\settings\videoconfig.cfg" "%dst%Saves"
COPY /Y "MDE1\settings\launcconfig.cfg" "%dst%Saves"

ECHO Copying game specific files...
XCOPY /E /I /Q /Y MDE1\sds_retail sds_retail
MOVE /Y RealVR64.dll dxgi.dll

ECHO Cleaning up...
RMDIR /S /Q MDE1
RMDIR /S /Q RDR2
GOTO finish


:abort
ECHO Aborting RealConfig
GOTO end
:finish
ECHO All done!
:end
PAUSE
